//  Drawing.c
// 
//  Version	Date	 Author	 Description
//	--------------------------------------------------------------------------
//  0.01	24/06/01 BWW	 Initial implementation

#include <c:\psx\include\libps.h>
#include "planner.h"
#include "funcprototypes.h"

extern	Agent_Struct	Agent;
extern	Key_Struct		Key;
extern	Exit_Struct		Exit;
extern	Door_Struct		Door[];
extern	Bridge_Struct	Bridge[];
extern	Route_Struct 	Route;

// Standard Text
extern	char 	TurnMsg[];
extern	long	Turn;

extern	char 	Environment[10][20];

// Flag whether to print Debug information
extern	int		Debug;

// Sprite structure
extern	GsSPRITE 	MessageSprite;

// Ordering table variables
extern	GsOT		WorldOT[2];
extern	GsOT_TAG	OTTags[2][1<<OT_LENGTH];

// Define the packet work area
extern	PACKET		GpuPacketArea[2][PACKETMAX2];

// Which buffer variable
extern	int			activeBuff;

//	--------------------------------------------------------------------------
// 	Close the Graphic Display
//	--------------------------------------------------------------------------
//	Description:	Close down the Playstation graphics system
//
//	Parameters:		None
//	Returns:		None

void DisplayClose()
	{
	ResetGraph(3);
	}
	
//	--------------------------------------------------------------------------
// 	Finish Drawing
//	--------------------------------------------------------------------------
//	Description:	Wait for the Playstation hardware to finish drawing
//
//	Parameters:		None
//	Returns:		None

void DisplayFinishDrawing()
	{
	// Wait for the hardware to finish drawing
	DrawSync(0);
	}

//	--------------------------------------------------------------------------
// 	Vertical Blank Sync
//	--------------------------------------------------------------------------
//	Description:	Wait for the Vertical Display Blank to happen 
//
//	Parameters:		None
//	Returns:		None

void DisplayVerticalBlank()
	{
	// Wait for the hardware to flag a vertical blank
	VSync(0);
	}

//	--------------------------------------------------------------------------
// 	Close the Drawing Cycle
//	--------------------------------------------------------------------------
//	Description:	Finish the current drawing cycle by swapping the buffers,
//					sorting the Ordering Table and then drawing them to the 
//					display 
//
//	Parameters:		None
//	Returns:		None

void DisplayCloseDrawingCycle()
	{
	// Switch display buffer & offscreen buffer
	GsSwapDispBuff();

	// Sort the ordering table
	GsSortClear(0,0,0,&WorldOT[activeBuff]);

	// Draw the objects registered in the Ordering table
	GsDrawOt(&WorldOT[activeBuff]);
	}

